clash-ghc-1.8.4: Clash: a functional hardware description language - GHC frontend

Copyright | (C) 2020-2021 QBayLogic B.V. 2022 Google Inc.
License | BSD2 (see the file LICENSE)
Maintainer | QBayLogic B.V. <devops@qbaylogic.com>
Safe Haskell | None
Language | Haskell2010

Clash.GHC.PartialEval.Eval

Description

This module provides the "evaluation" part of the partial evaluator. This is implemented in the classic "eval/apply" style, with a variant of apply for performing type applications.

Synopsis

- eval :: Term -> Eval Value
- apply :: Value -> Value -> Eval Value
- applyTy :: Value -> Type -> Eval Value

# Documentation

eval :: Term -> Eval Value Source #

Evaluate a term to WHNF.

apply :: Value -> Value -> Eval Value Source #

applyTy :: Value -> Type -> Eval Value Source #